/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokControllerActionDataLabelRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokControllerActionDataLabelRequest{}

// TikTokControllerActionDataLabelRequest struct for TikTokControllerActionDataLabelRequest
type TikTokControllerActionDataLabelRequest struct {
	ReportType  *string `json:"reportType,omitempty"`
	IdDimension *string `json:"idDimension,omitempty"`
}

// NewTikTokControllerActionDataLabelRequest instantiates a new TikTokControllerActionDataLabelRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokControllerActionDataLabelRequest() *TikTokControllerActionDataLabelRequest {
	this := TikTokControllerActionDataLabelRequest{}
	return &this
}

// NewTikTokControllerActionDataLabelRequestWithDefaults instantiates a new TikTokControllerActionDataLabelRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokControllerActionDataLabelRequestWithDefaults() *TikTokControllerActionDataLabelRequest {
	this := TikTokControllerActionDataLabelRequest{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *TikTokControllerActionDataLabelRequest) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionDataLabelRequest) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *TikTokControllerActionDataLabelRequest) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *TikTokControllerActionDataLabelRequest) SetReportType(v string) {
	o.ReportType = &v
}

// GetIdDimension returns the IdDimension field value if set, zero value otherwise.
func (o *TikTokControllerActionDataLabelRequest) GetIdDimension() string {
	if o == nil || IsNil(o.IdDimension) {
		var ret string
		return ret
	}
	return *o.IdDimension
}

// GetIdDimensionOk returns a tuple with the IdDimension field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionDataLabelRequest) GetIdDimensionOk() (*string, bool) {
	if o == nil || IsNil(o.IdDimension) {
		return nil, false
	}
	return o.IdDimension, true
}

// HasIdDimension returns a boolean if a field has been set.
func (o *TikTokControllerActionDataLabelRequest) HasIdDimension() bool {
	if o != nil && !IsNil(o.IdDimension) {
		return true
	}

	return false
}

// SetIdDimension gets a reference to the given string and assigns it to the IdDimension field.
func (o *TikTokControllerActionDataLabelRequest) SetIdDimension(v string) {
	o.IdDimension = &v
}

func (o TikTokControllerActionDataLabelRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokControllerActionDataLabelRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.IdDimension) {
		toSerialize["idDimension"] = o.IdDimension
	}
	return toSerialize, nil
}

type NullableTikTokControllerActionDataLabelRequest struct {
	value *TikTokControllerActionDataLabelRequest
	isSet bool
}

func (v NullableTikTokControllerActionDataLabelRequest) Get() *TikTokControllerActionDataLabelRequest {
	return v.value
}

func (v *NullableTikTokControllerActionDataLabelRequest) Set(val *TikTokControllerActionDataLabelRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokControllerActionDataLabelRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokControllerActionDataLabelRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokControllerActionDataLabelRequest(val *TikTokControllerActionDataLabelRequest) *NullableTikTokControllerActionDataLabelRequest {
	return &NullableTikTokControllerActionDataLabelRequest{value: val, isSet: true}
}

func (v NullableTikTokControllerActionDataLabelRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokControllerActionDataLabelRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
